<template>
  <PageContainer>
      <template slot="content" style="background-color: white">
            <div class='relative p-10 bg-gray-100 rounded-md mb-20'>
                <div class='text-center mb-12'>
                    <div class="title text-3xl font-semibold mb-2">Standard Tailwind CSS utilization</div>
                    <p>We can add tailwindcss utility classes in any <span class='font-bold'>DOM element</span> or <span class='font-bold'>Quasar components</span> of our Vue files, without theming!</p>
                </div>

                <div class="flex">
                    <div class="flex-1">
                        <div class="py-8 px-8 max-w-sm mx-auto bg-white rounded-xl shadow-md space-y-2 sm:py-4 sm:flex sm:items-center sm:space-y-0 sm:space-x-6">
                            <img class="block mx-auto h-24 rounded sm:mx-0 sm:flex-shrink-0" src="../../assets/images/office-chair3.jpg" alt="Woman's Face">
                            <div class="text-center space-y-2 sm:text-left">
                                <div class="space-y-0.5">
                                <p class="text-lg text-black font-semibold">
                                    Erin Lindford
                                </p>
                                <p class="text-gray-500 font-medium">
                                    Product Engineer
                                </p>
                                </div>
                                <button class="px-4 py-1 text-sm text-purple-600 font-semibold rounded-full border border-purple-200 hover:text-white hover:bg-purple-600 hover:border-transparent focus:outline-none focus:ring-2 focus:ring-purple-600 focus:ring-offset-2">Message</button>
                            </div>
                        </div>
                        <div class="text-center mt-3"><span class="font-bold">DOM element</span>, modified with Tailwind classes</div>
                    </div>

                    <div class="flex-1">
                        <q-card class="my-card mx-auto max-w-sm">
                            <q-card-section class="bg-gray-400 text-white">
                                <div class='text-white'>Our Changing Planet</div>
                                <div class="text-subtitle2">by John Doe</div>
                            </q-card-section>

                            <q-separator />

                            <q-card-actions align="right">
                                <q-btn flat class='border-green-400 border-solid border-2 rounded-3xl bg-green-400 text-white text-xs'>Confirm</q-btn>
                                <q-btn flat class='border-red-400 border-solid border-2 rounded-3xl bg-red-400 text-white text-xs'>Discard</q-btn>
                            </q-card-actions>
                        </q-card>
                        <div class="text-center mt-4"><span class="font-bold">Quasar q-card component</span>, modified with Tailwind classes</div>
                    </div>
                </div>
            </div>


            <div class='mb-5'>
                    <div class="title text-3xl font-semibold">Tailwind theme configuration</div>
                    <p>Using tailwind basic theme config, we can define multiple themes, each one defining its own CSS rules</p>
                    <div class="q-pa-md">
                        <div class="q-gutter-sm">
                        <q-radio @input="setTheme" v-model="theme" val="" label="Default Theme" />
                        <q-radio @input="setTheme" v-model="theme" val="semantic-ui-theme" label="Semantic UI" />
                        <q-radio @input="setTheme" v-model="theme" val="bootstrap-dark-ui-theme" label="Bootstrap Dark UI" />
                        <q-radio @input="setTheme" v-model="theme" val="full-white-ui-theme" label="Full White UI" />
                        </div>
                    </div>
            </div>
            <search-panel v-model="search" :columns="columns" />
            <MTable
                row-key="id"
                :data-source="items"
                :columns="columns"
                :display-view="display"
                :selected.sync="selected"
                :m-loading="loading"
                :m-filter="search"
                :pagination="pagination"
                @request="onRequest">
            </MTable>

            <div class='mt-10'>
                <div class="title text-3xl font-semibold">Tailwind themes & Classes combination</div>
                <p>Instead of defining CSS rules for each themes, we can make use of tailwind classes to define styles in our themes</p>
                <div class="q-pa-md mb-10">
                    <div class="q-gutter-sm">
                    <q-radio @input="setTheme" v-model="theme" val="" label="Default Theme" />
                    <q-radio @input="setTheme" v-model="theme" val="semantic-ui-theme" label="Semantic UI" />
                    <q-radio @input="setTheme" v-model="theme" val="bootstrap-dark-ui-theme" label="Bootstrap Dark UI" />
                    <q-radio @input="setTheme" v-model="theme" val="full-white-ui-theme" label="Full White UI" />
                    </div>
                </div>

                <div class="text-3xl font-semibold mb-5">Themed Components</div>
                <themed-buttons />
                <themed-form />
                <themed-radios />
                <themed-checkboxes />
                <themed-mselect />
                <themed-datepicker />
                <themed-dialog />
            </div>
    </template>
  </PageContainer>
</template>

<script>
import MTable from 'components/datatables/MTable'
import ThemedMselect from './themedMselect'
import ThemedButtons from './themedButtons'
import ThemedForm from './themedForm'
import ThemedRadios from './themedRadios'
import ThemedCheckboxes from './themedCheckboxes'
import ThemedDatepicker from './themedDatepicker'
import ThemedDialog from './themedDialog'
import SearchPanel from 'components/datatables/SearchPanel'
import PageContainer from 'components/PageContainer'
import { mapState, mapMutations } from 'vuex'
export default {
    components: {
        PageContainer,
        MTable,
        ThemedMselect,
        ThemedButtons,
        ThemedCheckboxes,
        ThemedForm,
        ThemedRadios,
        ThemedDatepicker,
        ThemedDialog,
        SearchPanel
    },
    data() {
        return {
            search: null,
            pagination: {
                sortBy: 'created_at',
                descending: true,
                page: 1,
                rowsPerPage: 10,
            },
            columns: [
                {
                name: 'id', field: 'id', label: 'Id', align: 'left',
                sortable: true, searchable: true, type: 'number',
                visible: true
                },
                {
                name: 'title', field: 'title', label: 'Title', align: 'left',
                visible: true, sortable: true, searchable: true, type: 'text',
                },
                {
                name: 'completed', field: 'completed', sortable: true,
                label: 'Completed', align: 'left', visible: true,
                },
            ],
            loading: false,
            actions: [],
            selected: [],
            grid: false,
            display: '',
        }
    },
    methods: {
        ...mapMutations('application', ['setDefaultTheme']),
        setTheme(theme) {
            this.setDefaultTheme({theme})
        },
        async onRequest(props) {
            this.loading = true
            try {
                let results = await this.$store.dispatch('tasks/index', props)
                this.pagination = {
                    ...props.pagination,
                    rowsNumber: parseInt(results.total),
                }
            }
            finally {
                this.loading = false
            }
        },
    },
    computed: {
        canCreate() {
        return true
        },
        canUpdate() {
        return true
        },
        ...mapState({
        theme: state => _.get(state, 'application.defaultTheme', '') || '',
        items: state => _.get(state, 'tasks.items', []) || [],
        })
    },
    async mounted() {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.search,
      });
    },
}
</script>